function [params,mop,pop,state,max_cv,percent]=evolution(params,mop,pop,state,Pushstage,Pullstage,epsilon_,max_cv)
    temp_cv = [];
    % 1)ӽӴ
    params.delta          = (1- state.reg_obj/params.iteration)^0.7;
    [newpop,state]        = CMOp(params,mop,pop,state);

    % 2)ͨѡӵõµȺ
    [pop,params,state]    = extractPop(pop,newpop,params,state,Pushstage,Pullstage,epsilon_);

    for i=1:params.num_class
        temp_cv = [temp_cv,pop(i).inter.cv];
    end
    temp_infea_cv = sort(temp_cv,'descend');
    if temp_infea_cv(1) > max_cv
        max_cv = temp_infea_cv(1);
    end
    fea=(temp_infea_cv(:,end)<1e-6);       
    percent=sum(fea)/params.popsize; 
end


%% Ⱥ
function [pop,params,state] = extractPop(pop,newpop,params,state,Pushstage,Pullstage,epsilon_)
    % ·ʽ   
     allind          = [pop.inter,newpop.inter];
     val             = [allind.objective];
     num_nod         = size(val,2);
     params.idealmin = min([params.idealmin,val],[],2);
     noval           = val-repmat(params.idealmin,[1,num_nod]);
     team            = group(params, pop, noval);
     for i=1:params.num_class
        num_p             = length(team{i});
        if num_p<=pop(i).num_ind
            tst                      = floor(num_nod*rand(1,pop(i).num_ind-num_p))+1;
            selind                   = allind([team{i},tst]);
            pop(i).inter             = selind;
        else
            selind                   = allind(team{i});
            pop(i).inter             = selection(params,selind,pop(i),Pushstage,Pullstage,epsilon_);
        end
     end 
end

%% Ӵ
function [newpop,state] = CMOp(params,mop,pop,state)
    PM          = [pop.inter];
    newpop      = pop;
    for i=1:params.num_class                                           % num_class ȺصĿ
        newinter    = pop(i).inter;                                    % inter Ⱥ
        for j=1:pop(i).num_ind                                         % num_ind ȺĹģ
            parent1=pop(i).inter(j);
            if rand>params.selectPro                                   % selectPro ôѡӽĸ壬ڷ㷨õ
                parent2  = PM(floor(rand*params.popsize)+1);
            else
                loc                 = floor(rand*pop(i).num_ind)+1;
                parent2             = pop(i).inter(loc);
            end
            childC                  = creChild(parent1,parent2,params,mop);
            childM                  = mutationOp(childC,params,mop);
            newinter(j)             = childM;
        end
        [newinter,state]            = evaluate(newinter,mop,state);
        N                           = length(newinter);
        cv                          = [newinter.c];
        cv                          = overall_cv(cv);
        cv                          = cv';  
       for n=1:N 
           [newinter(n).cv] = cv(n);
       end
        newpop(i).inter             = newinter;
    end
end

%% ӽ
function childind = creChild(parent1,parent2,params,mop)
    childind = get_structure( 'individual' );
    x1       = parent1.parameter;
    x2       = parent2.parameter;
    range_x  = mop.domain;
    rnd      = 2*(1-rand^(-params.delta))*(rand-0.5);
    x_cld    = x1+rnd*(x2-x1);
    for i = 1:mop.pd                                                       % pd:Աά 
        if x_cld(i) < range_x(i,1)
            x_cld(i) = range_x(i,1)+0.5*rand*(x1(i)-range_x(i,1));
        elseif x_cld(i) > range_x(i,2)
            x_cld(i) = range_x(i,2)-0.5*rand*(range_x(i,2)-x1(i));
        end
    end
    childind.parameter =x_cld;                                             % parameter:Ա
end

%% 
function childC = mutationOp(childC,params,mop)
    range_x       = mop.domain;
    x_cld         = childC.parameter;
    lst           = find(rand(1,mop.pd) <= params.pmuta);                  % pmuta: 
    len           = length(lst);
    if len == 0
        len = 1;
        lst = floor(rand*mop.pd)+1;
    end
    for j = 1:len
        yl  = range_x(lst(j),1);
        yu  = range_x(lst(j),2);
        y   = x_cld(lst(j));
        rnd = 0.5*(rand-0.5)*(1-rand^(-params.delta));                     % delta:ӽʱģ˻
        y   = y+rnd*(yu-yl);
        if y > yu
            y = yu-0.5*rand*(yu-x_cld(lst(j)));
        elseif y < yl
            y = yl+0.5*rand*(x_cld(lst(j))-yl);
        end
        x_cld(lst(j)) = y;
    end
    childC.parameter = x_cld;
end







