function [params,mop,pop_,state,max_cv,percent]=evolution_(params,mop,pop_,state,epsilon_,max_cv)
        params.delta           = (1- state.reg_obj/params.iteration)^0.7;
        [newpop,state]         = CMOp_(params,mop,pop_,state);
        [pop_,params,state]    = extractPop_(pop_,newpop,params,state,epsilon_);
        
        temp_cv = [pop_.cv];
        temp_infea_cv = sort(temp_cv,'descend');
        if temp_infea_cv(1) > max_cv
            max_cv = temp_infea_cv(1);
        end
        fea=(temp_infea_cv(:,end)<1e-6);       
        percent=sum(fea)/params.popsize; 
end

function [pop,params,state] = extractPop_(pop_,newpop,params,state,epsilon_)
    % ·ʽ   
     allind         = [pop_,newpop];
%      [pop]           = com_pop(state,params,allind);
     pop            = ndsort_(allind,epsilon_);
     pop            = selectNS(pop,params.popsize); 
end

%% Ӵ(10%)
function [newpop,state] = CMOp_(params,mop,pop_,state)
    for i=1:params.popsize                                           
        newpop   = pop_;                                                               
        parent1  = pop_(i);
        
        if rand>params.selectPro        
            parent2  = pop_(floor(rand*params.popsize)+1);
        else
            loc                 = floor(rand*33)+1;
            parent2             = pop_(loc);
        end
       
        %parent2  = pop_(floor(rand*params.popsize)+1);
        
        childC                  = creChild(parent1,parent2,params,mop);
        childM                  = mutationOp(childC,params,mop);
        newpop(i)               = childM;
    end   
        [newpop,state]          = evaluate(newpop,mop,state);
        N                       = length(newpop);
        cv                      = [newpop.c];
        cv                      = overall_cv(cv);
        cv                      = cv';  
       for n=1:N 
           [newpop(n).cv] = cv(n);
       end
end

%% ӽ
function childind = creChild(parent1,parent2,params,mop)
    childind = get_structure( 'individual' );
    x1       = parent1.parameter;
    x2       = parent2.parameter;
    range_x  = mop.domain;
    rnd      = 2*(1-rand^(-params.delta))*(rand-0.5);
    x_cld    = x1+rnd*(x2-x1);
    for i = 1:mop.pd                                                       % pd:Աά 
        if x_cld(i) < range_x(i,1)
            x_cld(i) = range_x(i,1)+0.5*rand*(x1(i)-range_x(i,1));
        elseif x_cld(i) > range_x(i,2)
            x_cld(i) = range_x(i,2)-0.5*rand*(range_x(i,2)-x1(i));
        end
    end
    childind.parameter =x_cld;                                             % parameter:Ա
end

%% 
function childC = mutationOp(childC,params,mop)
    range_x       = mop.domain;
    x_cld         = childC.parameter;
    lst           = find(rand(1,mop.pd) <= params.pmuta);                  % pmuta: 
    len           = length(lst);
    if len == 0
        len = 1;
        lst = floor(rand*mop.pd)+1;
    end
    for j = 1:len
        yl  = range_x(lst(j),1);
        yu  = range_x(lst(j),2);
        y   = x_cld(lst(j));
        rnd = 0.5*(rand-0.5)*(1-rand^(-params.delta));                     % delta:ӽʱģ˻
        y   = y+rnd*(yu-yl);
        if y > yu
            y = yu-0.5*rand*(yu-x_cld(lst(j)));
        elseif y < yl
            y = yl+0.5*rand*(x_cld(lst(j))-yl);
        end
        x_cld(lst(j)) = y;
    end
    childC.parameter = x_cld;
end

function nextpop = selectNS(pop,num)
    nextpop = pop(1:num);    %just for initializing
    rankVector = [pop.rank];
    n = 0;                  % individuals number of next population
    rank = 1;               % current rank number
    idx = find(rankVector == rank);
    numInd = length(idx);       % number of individuals in current front
    while( n + numInd <= num )
        nextpop( n+1 : n+numInd ) = pop( idx );
        n = n + numInd;
        rank = rank + 1;
        idx = find(rankVector == rank);
        numInd = length(idx);
    end
    if( n < num )
        distance   = [pop(idx).distance];
        distance   = [distance', idx'];
        distance   = sortrows( distance, -1);      
        idxSelect  = distance( 1:num-n, 2);          
        nextpop(n+1 : num) = pop(idxSelect);
    end
end






