function [params,mop,pop]=inputparams(name_f,params)
    
    % 1ʼǵЧ
%     if( strcmpi(params.isCauIGD, 'yes'))
%         PFStar          = load(strcat('PFStar/pf_',name_f,'.dat'));
%         params.PFStar   =  PFStar';
%     end
    
    % 2)ʼȺģȺĿ
    mop           = testmop(name_f);
    [params,mop]  = inputparameter(params,mop);
    
    
    % 4)ʼȨ
    if( strcmpi(params.useWeight, 'yes'))
        val_w                  = Weight(params.popsize,mop.od);
        val_w                  = val_w./repmat(sqrt(sum(val_w.^2)),[mop.od,1]);
        params.weight          = val_w;
        params.popsize         = size(val_w,2);
    end
    
    % 5)ʼĵȺĹģ
    val_cp                 = Weight(params.num_class,mop.od);
    center                 = val_cp./repmat(sqrt(sum(val_cp.^2)),[mop.od,1]);
    params.num_class       = size(center,2);
    sub                    = get_structure('subclass');
    pop                    = repmat(sub, [1,params.num_class]);
    for i=1:params.num_class
        pop(i).center         = center(:,i);
    end

    if( strcmpi(params.useWeight, 'yes'))
        team                      = group(params,pop,val_w);
        for i=1:params.num_class
            pop(i).weight         = 1./val_w(:,team{i});
            pop(i).num_ind        = length(team{i});
        end
    else
        temv1     = mod(params.popsize,params.num_class);
        temv2     = floor(params.popsize/params.num_class);
        for i=1:temv1
            pop(i).num_ind=temv2+1;
        end
        for i=temv1+1:params.num_class
            pop(i).num_ind=temv2;
        end
    end   
    params.pmuta           = 1/mop.pd;
    params.idealmin        = 1000000000000*ones(mop.od,1);    
end



function [params,mop]=inputparameter(params,mop)
    switch upper(mop.name)
      case {'LIRCMOP1','LIRCMOP2','LIRCMOP3','LIRCMOP4','LIRCMOP5','LIRCMOP6','LIRCMOP7','LIRCMOP8','LIRCMOP9','LIRCMOP10','LIRCMOP11','LIRCMOP12','LIRCMOP13','LIRCMOP14'}     
            params.iteration   = 300000;
            params.num_class   = 17;                                                   
            params.popsize     = 300; 
            params.maxgen      = params.iteration / params.popsize;
      case {'CF1','CF2','CF3','CF4','CF5','CF6','CF7'}                           
            params.iteration   = 100000;
            params.num_class   = 17;                                                  
            params.popsize     = 200;
            params.maxgen      = params.iteration / params.popsize;
     case {'CF8','CF9','CF10'}                           
            params.iteration   = 150000;
            params.num_class   = 17;                                                  
            params.popsize     = 300;
            params.maxgen      = params.iteration / params.popsize;
    case {'DASBCMOP1','DASBCMOP2','DASBCMOP3','DASBCMOP4','DASBCMOP5'}     
            params.iteration   = 300000;
            params.num_class   = 10;                                                   
            params.popsize     = 300; 
            params.maxgen      = params.iteration / params.popsize;
    case {'DASBCMOP6','DASBCMOP7'}     
            params.iteration   = 300000;
            params.num_class   = 15;                                                   
            params.popsize     = 300; 
            params.maxgen      = params.iteration / params.popsize;
    end 
end

function val_w = Weight(popsize,objDim)
    if objDim==2
        start      = 1/(popsize*100000);
        val_w(1,:) = linspace(start,1-start,popsize);
        val_w(2,:) = ones(1,popsize)-val_w(1,:);
    elseif objDim==3
        val_w = lhsdesign(popsize, 3, 'criterion','maximin')';
    end
end

