function p=CF10(p)
p.name='CF10';
p.od = 3;
p.pd = 30;
range = ones(p.pd,2);
range(1:2,1)    =  0;
range(3:p.pd,1)  = -2;
range(3:p.pd,2)  =  2;
p.domain=  range;
p.func = @evaluate;
%LZDT1  evaluation function.
    function [y,c] = evaluate(x)
        a           = 1.0;
        N           = 2.0;
        [dim, num]  = size(x);
        Y           = zeros(dim,num);
        Y(3:dim,:)  = x(3:dim,:) - 2.0*repmat(x(2,:),[dim-2,1]).*sin(2.0*pi*repmat(x(1,:),[dim-2,1]) + pi/dim*repmat((3:dim)',[1,num]));
        H           = zeros(dim,num);
        H(3:dim,:)  = 4.0*Y(3:dim,:).^2 - cos(8.0*pi*Y(3:dim,:)) + 1.0;
        tmp1        = sum(H(4:3:dim,:));  % j-1 = 3*k
        tmp2        = sum(H(5:3:dim,:));  % j-2 = 3*k
        tmp3        = sum(H(3:3:dim,:));  % j-0 = 3*k
        y(1,:)      = cos(0.5*pi*x(1,:)).*cos(0.5*pi*x(2,:)) + 2.0*tmp1/size(4:3:dim,2);
        y(2,:)      = cos(0.5*pi*x(1,:)).*sin(0.5*pi*x(2,:)) + 2.0*tmp2/size(5:3:dim,2);
        y(3,:)      = sin(0.5*pi*x(1,:))                     + 2.0*tmp3/size(3:3:dim,2);
        c(1,:)      = (y(1,:).^2+y(2,:).^2)./(1.0-y(3,:).^2) - a*sin(N*pi*((y(1,:).^2-y(2,:).^2)./(1.0-y(3,:).^2)+1.0)) - 1.0;
    end
end