function p=CF3(p)
p.name='CF3';
p.od = 2;
p.pd = 30;
range = ones(p.pd,2);
range(1,1)      =  0;
range(2:p.pd,1)  = -2;
range(2:p.pd,2)  =  2;
p.domain=  range;
p.func = @evaluate;
%LZDT1  evaluation function.
    function [y,c] = evaluate(x)
        a            = 1.0;
        N            = 2.0;
        [dim, num]   = size(x);
        Y            = zeros(dim,num);
        Y(2:dim,:)   = x(2:dim,:) - sin(6.0*pi*repmat(x(1,:),[dim-1,1]) + pi/dim*repmat((2:dim)',[1,num]));
        tmp1         = zeros(dim,num);
        tmp1(2:dim,:)= Y(2:dim,:).^2;
        tmp2         = zeros(dim,num);
        tmp2(2:dim,:)= cos(20.0*pi*Y(2:dim,:)./sqrt(repmat((2:dim)',[1,num])));
        tmp11        = 4.0*sum(tmp1(3:2:dim,:)) - 2.0*prod(tmp2(3:2:dim,:)) + 2.0;  % odd index
        tmp21        = 4.0*sum(tmp1(2:2:dim,:)) - 2.0*prod(tmp2(2:2:dim,:)) + 2.0;  % even index
        y(1,:)       = x(1,:)          + 2.0*tmp11/size(3:2:dim,2);
        y(2,:)       = 1.0 - x(1,:).^2 + 2.0*tmp21/size(2:2:dim,2);
        c(1,:)       = y(2,:) + y(1,:).^2 - a*sin(N*pi*(y(1,:).^2-y(2,:)+1.0)) - 1.0;
    end
end