function p=CF4(p)
p.name='CF4';
p.od = 2;
p.pd = 30;
range = ones(p.pd,2);
range(1,1)      =  0;
range(2:p.pd,1)  = -2;
range(2:p.pd,2)  =  2;
p.domain=  range;
p.func = @evaluate;
%LZDT1  evaluation function.
    function [y,c] = evaluate(x)
        [dim, num]  = size(x);
        tmp         = zeros(dim,num);
        tmp(2:dim,:)= x(2:dim,:) - sin(6.0*pi*repmat(x(1,:),[dim-1,1]) + pi/dim*repmat((2:dim)',[1,num]));
        tmp1        = sum(tmp(3:2:dim,:).^2);  % odd index
        tmp2        = sum(tmp(4:2:dim,:).^2);  % even index
        index1      = tmp(2,:) < (1.5-0.75*sqrt(2.0));
        index2      = tmp(2,:)>= (1.5-0.75*sqrt(2.0));
        tmp(2,index1) = abs(tmp(2,index1));
        tmp(2,index2) = 0.125 + (tmp(2,index2)-1.0).^2;
        y(1,:)      = x(1,:)                  + tmp1;
        y(2,:)      = 1.0 - x(1,:) + tmp(2,:) + tmp2;
        t           = x(2,:) - sin(6.0*pi*x(1,:)+2.0*pi/dim) - 0.5*x(1,:) + 0.25;
        c(1,:)      = sign(t).*abs(t)./(1.0+exp(4.0*abs(t)));
    end
end