function p=CF5(p)
p.name='CF5';
p.od = 2;
p.pd = 30;
range = ones(p.pd,2);
range(1,1)      =  0;
range(2:p.pd,1)  = -2;
range(2:p.pd,2)  =  2;
p.domain=  range;
p.func = @evaluate;
%LZDT1  evaluation function.
    function [y,c] = evaluate(x)
        [dim, num]  = size(x);
        tmp         = zeros(dim,num);
        tmp(2:dim,:)= x(2:dim,:) - 0.8*repmat(x(1,:),[dim-1,1]).*cos(6.0*pi*repmat(x(1,:),[dim-1,1]) + pi/dim*repmat((2:dim)',[1,num]));
        tmp1        = sum(2.0*tmp(3:2:dim,:).^2-cos(4.0*pi*tmp(3:2:dim,:))+1.0);  % odd index
        tmp(2:dim,:)= x(2:dim,:) - 0.8*repmat(x(1,:),[dim-1,1]).*sin(6.0*pi*repmat(x(1,:),[dim-1,1]) + pi/dim*repmat((2:dim)',[1,num]));
        tmp2        = sum(2.0*tmp(4:2:dim,:).^2-cos(4.0*pi*tmp(4:2:dim,:))+1.0);  % even index
        index1      = tmp(2,:) < (1.5-0.75*sqrt(2.0));
        index2      = tmp(2,:)>= (1.5-0.75*sqrt(2.0));
        tmp(2,index1) = abs(tmp(2,index1));
        tmp(2,index2) = 0.125 + (tmp(2,index2)-1.0).^2;
        y(1,:)      = x(1,:)                  + tmp1;
        y(2,:)      = 1.0 - x(1,:) + tmp(2,:) + tmp2;
        c(1,:)      = x(2,:) - 0.8*x(1,:).*sin(6.0*pi*x(1,:)+2.0*pi/dim) - 0.5*x(1,:) + 0.25;
    end
end