function p=CF7(p)
p.name='CF7';
p.od = 2;
p.pd = 30;
range = ones(p.pd,2);
range(1,1)      =  0;
range(2:p.pd,1)  = -2;
range(2:p.pd,2)  =  2;
p.domain=  range;
p.func = @evaluate;
%LZDT1  evaluation function.
    function [y,c] = evaluate(x)
        [dim, num]  = size(x);
        tmp         = zeros(dim,num);
        tmp(2:dim,:)= x(2:dim,:) - cos(6.0*pi*repmat(x(1,:),[dim-1,1]) + pi/dim*repmat((2:dim)',[1,num]));
        tmp1        = sum(2.0*tmp(3:2:dim,:).^2-cos(4.0*pi*tmp(3:2:dim,:))+1.0);  % odd index
        tmp(2:dim,:)= x(2:dim,:) - sin(6.0*pi*repmat(x(1,:),[dim-1,1]) + pi/dim*repmat((2:dim)',[1,num]));
        tmp2        = sum(2.0*tmp(6:2:dim,:).^2-cos(4.0*pi*tmp(6:2:dim,:))+1.0);  % even index
        tmp(2,:)    = tmp(2,:).^2;
        tmp(4,:)    = tmp(4,:).^2;
        y(1,:)      = x(1,:)                                  + tmp1;
        y(2,:)      = (1.0 - x(1,:)).^2 + tmp(2,:) + tmp(4,:) + tmp2;
        tmp         = 0.5*(1-x(1,:))-(1-x(1,:)).^2;
        c(1,:)      = x(2,:) - sin(6.0*pi*x(1,:)+2*pi/dim) - sign(tmp).*sqrt(abs(tmp));
        tmp         = 0.25*sqrt(1-x(1,:))-0.5*(1-x(1,:));
        c(2,:)      = x(4,:) - sin(6.0*pi*x(1,:)+4*pi/dim) - sign(tmp).*sqrt(abs(tmp));
    end
end