function p=DASBCMOP1(p)
p.name='DASBCMOP1';
p.od = 2;
p.pd = 10;
range = ones(p.pd,2);
range(:,1)      =  0;
p.domain=  range;
p.func = @evaluate;
%LZDT1  evaluation function.
    function [y,c] = evaluate(x)
        [dim, num]   = size(x);
        temp         = x(2:dim,:) - sin(pi*repmat(x(1,:),[dim-1,1])/2);
        Y            = zeros(dim,num);
        Y(2:dim,:)   = -0.9*(temp).^2+abs(temp).^0.6;
        g            = 1+1*sin(x(1,:)*pi)*sum(Y);
        y(1,:)       = x(1,:).*g;
        y(2,:)       = g.*(1-sqrt(x(1,:)));
        
        % Constrains
        sum1   = g;
        
        % set the parameters of constraints
        DifficultyFactors = [0.5,0,0];
        % Type-I parameters
        a = 20;
        b = 2 * DifficultyFactors(1) - 1;
        % Type-II parameters
        d = 0.5;
        if DifficultyFactors(2) == 0.0
            d = 0.0;
        end
        e = d - log(DifficultyFactors(2));
        if isfinite(e) == 0
            e = 1e+30;
        end
        % Type-III parameters
        r = 0.5 * DifficultyFactors(3);
        
%         PopObj = obj.CalObj(x);
        % Type-I constraints
        c(1,:) = sin(a * pi * x(1,:)) - b;
        % Type-II constraints
        c(2,:) = (e - sum1) .* (sum1 - d);
        if DifficultyFactors(2) == 1.0
            c(2,:) = 1e-4 - abs(sum1 - e);
        end
        % Type-III constraints
        p_k = [0.0, 1.0, 0.0, 1.0, 2.0, 0.0, 1.0, 2.0, 3.0];
        q_k = [1.5, 0.5, 2.5, 1.5, 0.5, 3.5, 2.5, 1.5, 0.5];
        a_k = 0.3;
        b_k = 1.2;
        theta_k = -0.25 * pi;
        for k=1:length(p_k)
%             c(2+k,:) = r - ((y(1,:) - p_k(k)) * cos(theta_k) - (y(2,:) - q_k(k)) * sin(theta_k)).^2 ./ a_k -...
%                 ((y(1,:) - p_k(k)) * sin(theta_k) + (y(2,:) - q_k(k)) * cos(theta_k)).^2 ./ b_k;
              c(2+k,:) = ((y(1,:) - p_k(k)) * cos(theta_k) - (y(2,:) - q_k(k)) * sin(theta_k)).^2 ./ a_k +...
                 ((y(1,:) - p_k(k)) * sin(theta_k) + (y(2,:) - q_k(k)) * cos(theta_k)).^2 ./ b_k - r; 
        end
    end
end