function p=DASBCMOP7(p)
p.name='DASBCMOP7';
p.od = 3;
p.pd = 10;
range = ones(p.pd,2);
range(:,1)      =  0;
p.domain=  range;
p.func = @evaluate;
%LZDT1  evaluation function.
    function [y,c] = evaluate(x)
        [dim, num]   = size(x);
        temp         = x(3:dim,:) - x(1,:).*x(2,:);
        Y            = zeros(dim,num);
        Y(3:dim,:)   = -0.9*temp.^2+abs(temp).^0.6;
        g            = 2*sum(Y).*sin(pi*x(1,:));
        y(1,:)       = (1+g).*cos(x(1,:)*pi/2).*cos(x(2,:)*pi/2);
        y(2,:)       = (1+g).*cos(x(1,:)*pi/2).*sin(x(2,:)*pi/2);
        y(3,:)       = (1+g).*sin(x(1,:)*pi/2);
        
        % Constrains
        sum1   = g;
        
        DifficultyFactors = [0.5,0,0];
        % Type-I parameters
        a = 20;
        b = 2 * DifficultyFactors(1) - 1;
        % Type-II parameters
        d = 0.5;
        if DifficultyFactors(2) == 0.0
            d = 0.0;
        end
        e = d - log(DifficultyFactors(2));
        if isfinite(e) == 0
            e = 1e+30;
        end
        % Type-III parameters
        r = 0.5 * DifficultyFactors(3);
        
        % Type-I constraints
        c(1,:) = sin(a * pi * x(1,:)) - b;
        c(2,:) = cos(a * pi * x(1,:)) - b;
        % Type-II constraints
        c(3,:) = (e - sum1) .* (sum1 - d);
        if DifficultyFactors(2) == 1.0
            c(3,:) = 1e-4 - abs(sum1 - e);
        end
        % Type-III constraints
        x_k = [1.0, 0.0, 0.0, 1.0 / sqrt(3.0)];
        y_k = [0.0, 1.0, 0.0, 1.0 / sqrt(3.0)];
        z_k = [0.0, 0.0, 1.0, 1.0 / sqrt(3.0)];
        
        for k=1:length(x_k)
            c(3+k,:) = ((y(1,:) - x_k(k))).^2  +...
                ((y(2,:) - y_k(k))).^2 - ((y(3,:) - z_k(k))).^2 - r * r;
        end
    end
end