function p=LIRCMOP13(p)
     p.name='LIRCMOP13';
     p.od = 3;
     p.pd = 30;
     range = ones(p.pd,2); 
     range(:,1)      =  0; 
     p.domain=  range;
     p.func = @evaluate;
    %LDTLZ2  evaluation function.
    function [y,c] = evaluate(x)
        variable_length=size(x,1);
        popsize=size(x,2);
        sum=zeros(1,popsize);
        for j=3:variable_length
            sum=sum+10*(x(j,:)-0.5).^2;
        end

        y(1,:)=(1.7057+sum).*cos(0.5*pi*x(1,:)).*cos(0.5*pi*x(2,:));
        y(2,:)=(1.7057+sum).*cos(0.5*pi*x(1,:)).*sin(0.5*pi*x(2,:));
        y(3,:)=(1.7057+sum).*sin(0.5*pi*x(1,:));
        %%%%%%%%% constraints %%%%%%%%%%%%%%%
        gx=y(1,:).^2+y(2,:).^2+y(3,:).^2;
        c=zeros(2,popsize);
        c(1,:)=(gx-9).*(gx-4);
        c(2,:)=(gx-3.61).*(gx-3.24);
    end
end