function p=LIRCMOP2(p)
     p.name='LIRCMOP2';
     p.od = 2;
     p.pd = 30;
     range = ones(p.pd,2); 
     range(:,1)      =  0; 
     p.domain=  range;
     p.func = @evaluate;
    %LZDT2  evaluation function.
    function [y,c] = evaluate(x)
        x_odd = x(3:2:end,:); x_even = x(2:2:end,:);
        len_odd = size(x_odd,1); len_even = size(x_even,1);
        g_1 = sum((x_odd - repmat(x(1,:),len_odd,1)).^2,1);
        g_2 = sum((x_even - repmat(x(1,:),len_even,1)).^2,1);

        y(1,:) = x(1,:) + g_1;
        y(2,:) = 1 - sqrt(x(1,:)) + g_2;

        % Constrains
        c(1,:) = (g_1 - 0.5).*(0.51 - g_1);
        c(2,:) = (g_2 - 0.5).*(0.51 - g_2);
    end
end