function p=LIRCMOP6(p)
     p.name='LIRCMOP6';
     p.od = 2;
     p.pd = 30;
     range = ones(p.pd,2); 
     range(:,1)      =  0; 
     p.domain=  range;
     p.func = @evaluate;
    %LDTLZ1  evaluation function.
    function [y,c] = evaluate(x)
        variable_length=size(x,1);
        popsize=size(x,2);
        sum1=zeros(1,popsize);
        sum2=zeros(1,popsize);
        for j=2:variable_length
            if mod(j,2)==1
                sum1=sum1+(x(j,:)-sin((0.5*j/variable_length*pi)*x(1,:))).^2;
            else
                sum2=sum2+(x(j,:)-cos((0.5*j/variable_length*pi)*x(1,:))).^2;
            end
        end
        gx=0.7057;
        y(1,:)=x(1,:)+10*sum1+gx;
        y(2,:)=1-x(1,:).^2+10.*sum2+gx;
        %%%%%%%%% constraints %%%%%%%%%%%%%%%
        %%%%%%%%% parameters %%%%%%%%%%%%%%%%
        p=[1.8,2.8];
        q=[1.8,2.8];
        a=[2,2];
        b=[8,8];
        r=0.1;theta=-0.25*pi;
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        c=zeros(2,popsize);
        for k=1:2
            c(k,:)=((y(1,:)-p(k))*cos(theta)-(y(2,:)-q(k))*sin(theta)).^2/(a(k)^2)+...
                ((y(1,:)-p(k))*sin(theta)+(y(2,:)-q(k))*cos(theta)).^2/(b(k)^2)-r;
        end
    end
end