function p=LIRCMOP9(p)
     p.name='LIRCMOP9';
     p.od = 2;
     p.pd = 30;
     range = ones(p.pd,2); 
     range(:,1)      =  0; 
     p.domain=  range;
     p.func = @evaluate;
    %LDTLZ2  evaluation function.
    function [y,c] = evaluate(x)
        variable_length=size(x,1);
        popsize=size(x,2);
        sum1=zeros(1,popsize);
        sum2=zeros(1,popsize);
        for j=2:variable_length
            if mod(j,2)==1
                sum1=sum1+(x(j,:)-sin((0.5*j/variable_length*pi)*x(1,:))).^2;
            else
                sum2=sum2+(x(j,:)-cos((0.5*j/variable_length*pi)*x(1,:))).^2;
            end
        end

        y(1,:)=1.7057*x(1,:).*(10*sum1+1);
        y(2,:)=1.7057*(1-x(1,:).^2).*(10*sum2+1);

        %%%%%%%%% constraints %%%%%%%%%%%%%%%
        %%%%%%%%% parameters %%%%%%%%%%%%%%%%
        p=1.4;
        q=1.4;
        a=1.5;
        b=6;
        r=0.1;alpha=0.25*pi;theta=-0.25*pi;
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        c=zeros(2,popsize);
        c(1,:)=(((y(1,:)-p)*cos(theta)-(y(2,:)-q)*sin(theta)).^2)/(a^2)+...
            (((y(1,:)-p)*sin(theta)+(y(2,:)-q)*cos(theta)).^2)/(b^2)-r;
        c(2,:)=y(1,:)*sin(alpha)+y(2,:)*cos(alpha)-sin(4*pi*(y(1,:)*cos(alpha)-y(2,:)*sin(alpha)))-2;
    end
end